#include <cstdlib>
#include <iostream>
#include <math.h>
#include "Stack.h"
#define expressionLength 100

using namespace std;

/* Function to check whether operand is an integer */
bool isOperand(char *str)
{
 for(int i=0; i<strlen(str); i++)
 {
  if((str[i]>= '0') && (str[i]<= '9'))
  {
   //continue
  } 
  else
   return false;
 }
   return true;
}

/* Function to check whether operator is +, -, *, / or ^ */
bool isOperator(char *str)
{
  if(strlen(str)== 1)
    return ( (*str=='+') || (*str=='-') || (*str== '*') || (*str=='/') || (*str=='^') );
  
  return false;
}

/* Function to apply operator on the operands */
int process(int op1, int op2, char operation)
{
 if(operation == '+')  return (op1 + op2);
 if(operation == '-')  return (op1 - op2);
 if(operation == '*')  return (op1 * op2);
 if(operation == '/')  return (op1 / op2);
 if(operation == '^')  return (int(pow(op1, op2)));
}


int main(int argc, char *argv[])
{
 char expression[expressionLength];
 char *ptr;
 int operand, op1, op2, result;
 char operation, choice;
 Stack operandStack;
 
 while(1)
 {
  cout<<"Enter postfix expression to evaluate:"<<endl;
  cin.getline(expression, expressionLength);
  ptr = strtok (expression," "); //strtok will return string before first space

  while (ptr != NULL)        //continue until strtok returns NULL in ptr 
  {
  
   if(isOperand(ptr))
   {
    operand = atoi(ptr);
    operandStack.push(operand);
   }
   else if(isOperator(ptr))
   {
    operation = ptr[0];
    if(operandStack.isEmpty())
    {
     cout<<"Error: Invalid postfix expression."<<endl;
     goto again;
    }
    op2 = operandStack.pop();      //pop operand from stack and store into op2
   
    if(operandStack.isEmpty())
    {
     cout<<"Error: Two operands required for "<<ptr<<" operator."<<endl;
     goto again;
    }
    if(op2== 0 && operation== '/')
    {
     cout<<"Error: Division by zero not allowed."<<endl;
     goto again;
    }
    op1 = operandStack.pop();  //pop operand from stack and store into op1
    result = process(op1, op2, operation);
    operandStack.push(result); //push the result again onto stack
   }
   else  //it's neither operand nor operator
   {
    cout<<ptr<<" is not valid for this program."<<endl;
    goto again;
   }
   ptr = strtok (NULL, " "); //continue breaking string on space
  
  } //end of while (ptr != NULL)
 
 result = operandStack.pop();   //pop final result from the stack
 if(operandStack.isEmpty())     //stack must be empty after popping the result
   cout<<"The result is: "<<result<<endl;
 else
   cout<<"Error: Too few operators."<<endl;

again: operandStack.clear();     //before starting again, clear the stack contents
 cout<<"Do you want to enter another postfix expression to evaluate? [Y/N]"<<endl; 
 cin>>choice;
 cin.sync();
 if(choice== 'n' || choice== 'N') 
  break;
 } //end of while(1)

 cout<<"Thank you for using this program."<<endl;
 
 system("PAUSE");
 return EXIT_SUCCESS;
} //end of main
